package com.adventurer_engine.util.blockbench;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.adventurer_engine.util.IReadJsonable;
import com.adventurer_engine.util.JsonHelper;
import com.adventurer_engine.util.blockbench.BBModel;
import com.adventurer_engine.util.blockbench.BBModelElement;
import java.util.LinkedList;
import java.util.List;

public class BBModelOutliner implements IReadJsonable {
  public String name;
  
  public double[] origin;
  
  public double[] rotation;
  
  public int color;
  
  public String uuid;
  
  public boolean export;
  
  public boolean mirror_uv;
  
  public boolean isOpen;
  
  public boolean locked;
  
  public boolean visibility;
  
  public List<BBModelElement> children_element;
  
  public List<com.adventurer_engine.util.blockbench.BBModelOutliner> children_outliner;
  
  public BBModelOutliner(JsonHelper json) {
    readJson(json);
    BBModel.outlinerMap.put(this.uuid, this);
  }
  
  public void readJson(JsonHelper json) {
    this.name = json.getString("name");
    (new double[3])[0] = 0.0D;
    (new double[3])[1] = 0.0D;
    (new double[3])[2] = 0.0D;
    this.origin = json.hasKey("origin") ? json.getDoubleArray("origin") : new double[3];
    (new double[3])[0] = 0.0D;
    (new double[3])[1] = 0.0D;
    (new double[3])[2] = 0.0D;
    this.rotation = json.hasKey("rotation") ? json.getDoubleArray("rotation") : new double[3];
    this.color = json.getInt("color");
    this.uuid = json.getString("uuid");
    this.export = json.getBoolean("export");
    this.mirror_uv = (json.hasKey("mirror_uv") && json.getBoolean("mirror_uv"));
    this.isOpen = (json.hasKey("isOpen") && json.getBoolean("isOpen"));
    this.locked = (json.hasKey("locked") && json.getBoolean("locked"));
    this.visibility = (json.hasKey("visibility") && json.getBoolean("visibility"));
    List<String> childrenUUID = json.getStringArray("children");
    this.children_element = new LinkedList<BBModelElement>();
    for (String uid : childrenUUID)
      this.children_element.add((BBModelElement)BBModel.elementMap.get(uid)); 
    List<JsonHelper> childrenOutliner = json.getJsonList("children");
    this.children_outliner = new LinkedList<com.adventurer_engine.util.blockbench.BBModelOutliner>();
    for (JsonHelper jh : childrenOutliner)
      this.children_outliner.add(new com.adventurer_engine.util.blockbench.BBModelOutliner(jh)); 
  }
}
